Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bugzilla DB migration completed. Please report issues to Infra team via email via infra@gentoo.org or IRC
Bug 634770 - [vmware] app-emulation/vmware-workstation-14.0.0: multiple CVE
Summary: [vmware] app-emulation/vmware-workstation-14.0.0: multiple CVE
Status: RESOLVED OBSOLETE
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Gentoo VMWare Bug Squashers [disabled]
URL:
Whiteboard:
Keywords:
: 635688 (view as bug list)
Depends on:
Blocks: 635688
  Show dependency tree
 
Reported: 2017-10-19 12:23 UTC by Manfred Knick
Modified: 2019-02-27 09:27 UTC (History)
7 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
vmware-workstation-14.0.0.6661328.ebuild (vmware-workstation-14.0.0.6661328.ebuild,16.87 KB, text/plain)
2017-11-05 14:30 UTC, Manfred Knick
Details
emerge --info (0_emerge--info.txt,5.74 KB, text/plain)
2017-11-05 14:38 UTC, Manfred Knick
Details
build.log (build.log,26.36 KB, text/x-log)
2017-11-05 14:52 UTC, Manfred Knick
Details
/usr/lib/vmware* (0__ll.txt,3.05 KB, text/plain)
2017-11-05 15:21 UTC, Manfred Knick
Details
vmware-workstation-14.0.0.6661328.ebuild (vmware-workstation-14.0.0.6661328.ebuild,20.14 KB, text/plain)
2017-11-06 13:24 UTC, Manfred Knick
Details
/usr/local/portage/local-overlay :: app-emulation.tar (app-emulation.tar,270.00 KB, application/x-tar)
2017-11-06 13:26 UTC, Manfred Knick
Details
/usr/local/portage/local-overlay/app-emulation.tar (app-emulation.tar,110.00 KB, application/x-tar)
2017-11-16 23:56 UTC, Manfred Knick
Details
/usr/local/portage/local-overlay/app-emulation.tar (app-emulation.tar,240.00 KB, application/x-tar)
2017-11-17 14:11 UTC, Manfred Knick
Details
app-emulation_vmware-r2-r6.tar (app-emulation_vmware-r2-r6.tar,110.00 KB, application/x-tar)
2017-11-29 10:25 UTC, Manfred Knick
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Manfred Knick 2017-10-19 12:23:39 UTC
Assignee: 	Gentoo VMWare Bug Squashers
-------------------------------------------

vmware-workstation version 13 has been skipped by VMware.

vmware-workstation version 14 has been released:

https://blogs.vmware.com/workstation/2017/09/workstation-14-now-available.html

https://www.vmware.com/products/personal-desktop-virtualization.html

https://docs.vmware.com/en/VMware-Workstation-Pro/14.0.0/rn/workstation-14-release-notes.html

. . . VMware Workstation 14 Pro | 26 Sep 2017 | Build 6661328


Older CPUs might need

. . . monitor.allowLegacyCPU = "true"


-------------------------
REFERENCE:  pre-decessor:

Bug 616958
   app-emulation/vmware-workstation-12.5.7 version bump
Comment 1 Manfred Knick 2017-10-20 08:32:54 UTC
REFERENCE:

Bug 634854 - app-emulation/vmware-tools-10.1.15-6627299 : version bump
Comment 2 Manfred Knick 2017-10-20 08:59:47 UTC
DOWNLOAD:

http://softwareupdate.vmware.com/cds/vmw-desktop/ws/14.0.0/6661328/linux/core/
VMware-Workstation-14.0.0-6661328.x86_64.bundle.tar

corresponds to
   HOMEPAGE=
   BASE_URI=
in current ebuild nomenclature.
Comment 3 Manfred Knick 2017-10-20 09:25:28 UTC
REFERENCE:

Bug 634862 - app-emulation/vmware-modules ... version bump
Comment 4 Manfred Knick 2017-10-20 09:29:14 UTC
"
New GTK+ 3 based UI for Linux
Linux Workstation UI has been rewritten to support GTK+ 3.
"

Thus, current dependency
. . . x11-libs/gtk+:2
has to change to
. . . x11-libs/gtk+:3
Comment 5 Manfred Knick 2017-10-24 21:57:11 UTC
@rjp421 (PM question) :

"System Requirements"
"Systems using Processors (CPUs) launched in 2011 or later are supported ..."
...


As a rule of thumb for Intel CPUs, the _INCISION_ aimed at seems to be:

  "In early 2011, Intel introduced a new _microarchitecture_ named Sandy Bridge. 
   This is the second generation Core processor microarchitecture."

Introducing e.g. 
- 256-bit instruction sets (AVX) instead of 128 Bit (SSE4), 
- Power Control, 
- iGPU, ...
the basics of that microarchitecture were carried on from then 32mm 
up to today's 14nm++ CPUs.
Comment 6 Manfred Knick 2017-11-01 21:01:42 UTC
    EAPI=5          # any experienced volunteer to change to current EAPI=6 ?

    PV_MODULES="308.$(...)      -->     329.$(...)        <--- !

    SYSTEMD_UNITS_TAG="gentoo-02"       ? still up-to-date ?

O.K., let's start with some diligent but routine piece of work:


Diff-Analyzing /usr/lib/vmware/lib :

    /var/lib/layman/vmware/app-emulation/vmware-workstation

    -> vmware-workstation-12.5.7.5813279.ebuild :


BUNDLED_LIBS=

    libcrypto.so.1.0.1      -->     1.0.2

    libgailutil.so.18       -->     3.10.0

    libgcrypt.so.11         -->     3.10.20

    libssl.so.1.0.1         -->     1.0.2

BUNDLED_LIB_DEPENDS=

    dev-libs/libgcrypt:11/11 -->    1.8.1:0/20

    x11-libs/gtk+:2         -->     :3


new entries in /usr/lib/vmware/lib :

    diskLibWrapper.so/diskLibWrapper.so

    libatk-bridge-2.0.so.0/libatk-bridge-2.0.so.0

    libbasichttp.so/libbasichttp.so
    libcairo-gobject.so.2/libcairo-gobject.so.2
    libcairomm-1.0.so.1/libcairomm-1.0.so.1

    libcds.so/libcds.so
    libcroco-0.6.so.3/libcroco-0.6.so.3

    libepoxy.so.0/libepoxy.so.0
    libexpat.so.1/libexpat.so.1
    libffi.so.6/libffi.so.6

    libgck-1.so.0/libgck-1.so.0
    libgcr-base-3.so.1/libgcr-base-3.so.1
    libgcr-ui-3.so.1/libgcr-ui-3.so.1

    libgdk-3.so.0/libgdk-3.so.0
    libgdkmm-3.0.so.1/libgdkmm-3.0.so.1

    libgdk-3.so.0/libgdk-3.so.0
    libgdkmm-3.0.so.1/libgdkmm-3.0.so.1

    libgiomm-2.4.so.1/libgiomm-2.4.so.1

    libglibmm-2.4.so.1/libglibmm-2.4.so.1
 
    ibgtk-3.so.0/libgtk-3.so.0
    libgtkmm-3.0.so.1/libgtkmm-3.0.so.1

    libgvmomi.so/libgvmomi.so
    libharfbuzz.so.0/libharfbuzz.so.0
    libICE.so.6/libICE.so.6
    libjpeg.so.62/libjpeg.so.62
    iblicenseTool.so/liblicenseTool.so
    libnfc-types.so/libnfc-types.so
    libp11-kit.so.0/libp11-kit.so.0

    libpcre.so.1/libpcre.so.1

    libSM.so.6/libSM.so.6

    libssl.so.1.0.2/libssl.so.1.0.2
    libssoclient.so/libssoclient.so

    libsvga3dsw.so/libsvga3dsw.so
    libtasn1.so.6/libtasn1.so.6
    libtiff.so.5/libtiff.so.5
    libvim-types.so/libvim-types.so
    
    libxcb.so.1/libxcb.so.1

    libXext.so.6/libXext.so.6
    
    libXi.so.6/libXi.so.6
    
    libXtst.so.6/libXtst.so.6
    libz.so.1/libz.so.1
Comment 7 Manfred Knick 2017-11-05 12:47:34 UTC
ERROR CORRECTION comment #6 :

> BUNDLED_LIBS=

>     libgailutil.so.18       -->     3.10.0
      libgailutil.so.18       -->     -3.so.0      <---
 
>     libgcrypt.so.11         -->     3.10.20
      libgcrypt.so.11         -->     so.20        <---

> BUNDLED_LIB_DEPENDS=

>     dev-libs/libgcrypt:11/11 -->    1.8.1:0/20
      dev-libs/libgcrypt:11/11 -->    :0/20        <---

Sorry for the c'n'p .
Comment 8 Manfred Knick 2017-11-05 14:30:10 UTC
Created attachment 502696 [details]
vmware-workstation-14.0.0.6661328.ebuild

/usr/local/portage/local-overlay/app-emulation/vmware-modules/vmware-workstation-14.0.0.6661328.ebuild

adapted from OVERLAY:

app-emulation/vmware-workstation-12.5.7.5813279:0::vmware


STATUS:

 app-emulation/vmware-workstation-14.0.0.6661328::mkn_local_overlay
 USE="cups doc ovftool server vix vmware-tools -bundled-libs"

   + Extracting ...
   + Removing bundled libraries
   + Source prepared.
   + Source configured.
   + Source compiled.                 <--- !
but
   - Install ... fails
with

   !!! dobin: bin/* does not exist
    * ERROR: app-emulation/vmware-workstation-14.0.0.6661328::mkn_local_overlay
             failed (install phase):
    *   dobin failed

Findings:

First, vmware-tools succeed to install:
   "insinto "${VM_INSTALL_DIR}"/lib/vmware/isoimages"

   # ls /opt/vmware/lib/vmware/isoimages/
     freebsd.iso  freebsd.iso.sig  linux.iso  linux.iso.sig  solaris.iso  
     solaris.iso.sig  windows.iso  windows.iso.sig

Second, vmware-tools -> Install phase fails to create the needed

   /opt/vmware/bin

Ebuild CODE line 247..249:

    # install the binaries
    into "${VM_INSTALL_DIR}"
    dobin bin/*
Comment 9 Manfred Knick 2017-11-05 14:38:29 UTC
Created attachment 502698 [details]
emerge --info

emerge --info 
'=app-emulation/vmware-workstation-14.0.0.6661328::mkn_local_overlay' 
> 0_emerge--info.txt
Comment 10 Manfred Knick 2017-11-05 14:50:35 UTC
$ emerge -pqv 
 '=app-emulation/vmware-workstation-14.0.0.6661328::mkn_local_overlay'

[ebuild  NS   ] media-libs/libpng-1.2.57 [1.6.32] ABI_X86="(64) -32 (-x32)" 

[ebuild  N    ] dev-util/patchelf-0.9 

[ebuild  N    ] app-emulation/vmware-tools-10.1.15.6627299
  USE="vmware_guest_freebsd vmware_guest_linux vmware_guest_solaris vmware_guest_windows -vmware_guest_netware -vmware_guest_winPre2k -vmware_guest_winPreVista" 

[ebuild  N    ] app-emulation/vmware-workstation-14.0.0.6661328
  USE="cups doc ovftool server vix vmware-tools -bundled-libs" 

[ebuild  N    ] app-emulation/vmware-modules-329.0.0
  USE="-pax_kernel -vmci -vsock"
Comment 11 Manfred Knick 2017-11-05 14:52:33 UTC
Created attachment 502700 [details]
build.log

/var/tmp/portage/app-emulation/vmware-workstation-14.0.0.6661328/temp/build.log
Comment 12 Manfred Knick 2017-11-05 15:21:45 UTC
Created attachment 502704 [details]
/usr/lib/vmware*

VMware 14.0.0 Installer does not install to /opt, but to

  /usr/lib/vmware
  /usr/lib/vmware-installer
  /usr/lib/vmware-ovftool
Comment 13 Manfred Knick 2017-11-05 17:17:46 UTC
Cross-checking:
Even with vmware-tools being disabled:

=app-emulation/vmware-workstation-12.5.7.5813279:0
      -bundled-libs -vmware-tools

does provide

     # ll /opt/vmware/

     drwxr-xr-x 2 root root 4,0K  5. Nov 17:22 bin
     drwxr-xr-x 3 root root 4,0K  5. Nov 17:22 lib

on it's own.

Thus,
without the slightest change in src_install(),
the root cause should be expected in the new packaging of 14.0.0
Comment 14 Manfred Knick 2017-11-05 17:53:46 UTC
==========================================
! EOL notice for Vmware-workstation-12.* :
==========================================

     END OF GENERAL SUPPORT:     2018 / 02 / 25

     END OF TECHNICAL GUIDANCE:        N.A.

https://www.vmware.com/content/dam/digitalmarketing/vmware/en/pdf/support/product-lifecycle-matrix.pdf
Comment 15 Manfred Knick 2017-11-06 13:24:13 UTC
Created attachment 502792 [details]
vmware-workstation-14.0.0.6661328.ebuild

Preliminary result:

compiles / installs with  +bundled-libs -server -vix:

app-emulation/vmware-modules            -vmci -vsock
app-emulation/vmware-workstation        bundled-libs doc ovftool # server vix

Lot's of "TODO" in the ebuild ...
Comment 16 Manfred Knick 2017-11-06 13:26:48 UTC
Created attachment 502796 [details]
/usr/local/portage/local-overlay  ::  app-emulation.tar

preliminary state

derived from OVERLAY
Comment 17 Ștefan Talpalaru 2017-11-07 06:58:50 UTC
vmware-modules-329.0.0 and vmware-workstation-14.0.0.6661328 are available in my overlay: https://github.com/stefantalpalaru/gentoo-overlay

Ebuilds based on the ones in the "vmware" overlay, with additions from Arch Linux (https://aur.archlinux.org/packages/vmware-workstation/) and some fixes of my own.

Please test it before I start working on vmware-player.
Comment 18 Manfred Knick 2017-11-10 08:10:59 UTC
(In reply to Ștefan Talpalaru from comment #17)


# cat /var/tmp/portage/app-emulation/vmware-workstation-14.0.0.6661328/temp/build.log

 * VMware-Workstation-14.0.0-6661328.x86_64.bundle.tar SHA256 SHA512 WHIRLPOOL size ;-) ...                                                                                                                                                                                                           [ ok ]
 * Package:    app-emulation/vmware-workstation-14.0.0.6661328
 * Repository: mkn_local_overlay
 * Maintainer: vmware@gentoo.org
 * USE:        abi_x86_64 amd64 elibc_glibc kernel_linux userland_GNU
 * FEATURES:   keeptemp keepwork preserve-libs sandbox userpriv usersandbox
>>> Unpacking source...
>>> Unpacking VMware-Workstation-14.0.0-6661328.x86_64.bundle.tar to /var/tmp/portage/app-emulation/vmware-workstation-14.0.0.6661328/work
Extracting VMware Installer...done.

User interface initialization failed.  Exiting.  Check the log for details.

rm: cannot remove 'extracted/vmware-ovftool': No such file or directory
 * ERROR: app-emulation/vmware-workstation-14.0.0.6661328::mkn_local_overlay failed (unpack phase):
 *   unable to remove dir
 * 
 * Call stack:
 *     ebuild.sh, line 124:  Called src_unpack
 *   environment, line 3403:  Called die
 * The specific snippet of code:
 *           rm -r extracted/vmware-ovftool || die "unable to remove dir";


# ll /var/tmp/portage/app-emulation/vmware-workstation-14.0.0.6661328/work

-rw-r--r-- 1 portage portage 1,2K 18. Sep 15:23 descriptor.xml
-rwxr-xr-x 1 portage portage 140M 18. Sep 15:23 VMware-Workstation-14.0.0-
                                                        6661328.x86_64.bundle


environment, line 3396..3404 :

src_unpack ()
{
    default;
    local bundle=${MY_P}.x86_64.bundle;
    chmod 755 ${bundle};
    ./${bundle} --console --extract extracted;
    if ! use ovftool; then
        rm -r extracted/vmware-ovftool || die "unable to remove dir";   <---
    fi;
Comment 19 Manfred Knick 2017-11-10 08:17:28 UTC
My impression is that failure already occurs in

     "
      Extracting VMware Installer...done.
      User interface initialization failed.
     "
because

     /var/tmp/portage/app-emulation/vmware-workstation-14.0.0.6661328/work

does not contain any extracts at all.
Comment 20 Manfred Knick 2017-11-12 19:24:43 UTC
missing:

. . . sys-libs/ncurses:5/5
Comment 21 Manfred Knick 2017-11-12 19:27:19 UTC
(In reply to Manfred Knick from comment #20)
With
> . . . sys-libs/ncurses:5/5 , 

eg.

$ sudo  bash 
        ./VMware-Workstation-14.0.0-6661328.x86_64.bundle
        --console   --extract=my-extract
works.

Placed it into DEPEND .
Comment 22 Manfred Knick 2017-11-12 19:50:57 UTC
AFAICS,  the following is OBSOLETE :

DOC_CONTENTS="
   ...
   You MUST set USE=bundled-libs if you are running gcc-5, 
   otherwise vmware will not start.
"
Comment 23 Manfred Knick 2017-11-12 21:20:00 UTC
After manually installing ( --oneshot ) sys-libs/ncurses:5/5,

emerge / install of just updated vmware-workstation -r1 succeeded.

####################################################################

Following emerge of vmware-modules -r1 fails in src_prepare() :

. . . epatch "${FILESDIR}/${PV_MAJOR}-vmblock.patch"


 * Cannot find $EPATCH_SOURCE!  Value for $EPATCH_SOURCE is:
 * 
 *   /var/tmp/portage/app-emulation/vmware-modules-329.0.0-r1/files/
                                                           329-vmblock.patch
 *   ( 329-vmblock.patch )

 * ERROR: app-emulation/vmware-modules-329.0.0-r1::mkn_local_overlay failed 
                                                             (prepare phase):
 *   Cannot find $EPATCH_SOURCE!
 
BUT:

# ll /var/tmp/portage/app-emulation/vmware-modules-329.0.0-r1/temp/build.log

perfectly yields

-rw-rw---- 1 portage portage 2,1K 12. Nov 22:15 
     /var/tmp/portage/app-emulation/vmware-modules-329.0.0-r1/temp/build.log

Strange.
Comment 24 Manfred Knick 2017-11-12 21:44:40 UTC
@ Ștefan : 

First of all:  ! Thank you very much for your work !


IUSE_VMWARE_GUESTS="${DARWIN_GUESTS} freebsd linux linuxPreGlibc25
                               netware solaris windows winPre2k winPreVista"


Do I understand correctly
that this vmware-workstation-ebuild obsoletes vmware-tools
and it's USE-flags,
in favour of "by-default" installing tools for *all* possible clients?

That would be a non-trivial change to the overlay
and should be decided upon / pointed out explicitly.
Comment 25 Manfred Knick 2017-11-12 22:18:04 UTC
(In reply to Manfred Knick from comment #23)

> Strange.

CONFIRMATION:

After rigorous clean-out,
emerge succeeded,
as well as a first start of Workstation
as well as a first start of linux-client (Fedora -> "dnf update" )
as well as a first start of Win10_1703_German_x64
including "revert to snapshot".

Great.


FEDORA: Re-Install VMware Tools fails  -  no ISO :

   ll /opt/vmware/lib/vmware/isoimages/

   -rw-r--r-- 1 root root 4,9K 12. Nov 22:47 isoimages_manifest.txt
   -rw-r--r-- 1 root root  451 12. Nov 22:47 tools-key.pub


"Hardware acceleration not available" :

   that may be due to my [GeForce GTX 660 Ti]
Comment 26 Manfred Knick 2017-11-12 22:44:43 UTC
(In reply to Manfred Knick from comment #25)

> "Hardware acceleration not available" :
> 
>    that may be due to my [GeForce GTX 660 Ti]

  System Requirements

    For 3D Graphics Hardware Acceleration support in a virtual machine:

      3GB RAM (Host PC)

      NVIDIA GeForce 9900GT and above or ATI Radeon HD 2600 and above

[ https://www.vmware.com/uk/products/workstation-pro/faqs.html ]


  3D-Grafiken mit DX10- und OpenGL 3.3-Unterstützung

[ https://www.vmware.com/de/products/workstation-pro.html ]

Both informations are compliant, resulting in

. . . DirectX 10  && OpenGL 3.3
Comment 27 Manfred Knick 2017-11-12 22:47:13 UTC
(In reply to Manfred Knick from comment #25)
> FEDORA: Re-Install VMware Tools fails  -  no ISO :
Installed my vmware-tools package:

# ll /opt/vmware/lib/vmware/isoimages/

-rw-r--r-- 1 root root  17M 12. Nov 23:19 freebsd.iso
-rw-r--r-- 1 root root  256 12. Nov 23:19 freebsd.iso.sig
-rw-r--r-- 1 root root 4,9K 12. Nov 22:47 isoimages_manifest.txt
-rw-r--r-- 1 root root  56M 12. Nov 23:19 linux.iso
-rw-r--r-- 1 root root  256 12. Nov 23:19 linux.iso.sig
-rw-r--r-- 1 root root  16M 12. Nov 23:19 solaris.iso
-rw-r--r-- 1 root root  256 12. Nov 23:19 solaris.iso.sig
-rw-r--r-- 1 root root  451 12. Nov 22:47 tools-key.pub
-rw-r--r-- 1 root root  96M 12. Nov 23:19 windows.iso
-rw-r--r-- 1 root root  256 12. Nov 23:19 windows.iso.sig

Re-Install Win-10 worked.

Re-Install Fedora needs an install of missing xterm package first.
Comment 28 Manfred Knick 2017-11-12 23:06:39 UTC
# /etc/init.d/vmware stop

* Stopping VMware USB Arbitrator ...

vmware-usbarbitrator: Kein Prozess gefunden                             [ !! ]

Stopped all configured services on all networks                         [ ok ]

 * Stopping VMware services ...

modprobe: FATAL: Module vmw_vsock_vmci_transport is builtin.            [ !! ]

modprobe: FATAL: Module vmw_vmci is builtin.                            [ !! ]

 * ERROR: vmware failed to stop


Reminds me of

Bug 510156 - app-emulation/vmware-workstation-{11,12} 
           - "/etc/init.d/vmware stop" fails 
             if vsock module is built into kernel 

especially Fabio's c.8

[ https://bugs.gentoo.org/510156#c8 ]
Comment 29 Manfred Knick 2017-11-12 23:12:55 UTC
(In reply to Manfred Knick from comment #26)
> (In reply to Manfred Knick from comment #25)
Re-Introducing

. . . mks.gl.allowBlacklistedDrivers = "TRUE"

deleted by etc-update

into /etc/vmware/config

vanished those Error messages.
Comment 30 Manfred Knick 2017-11-12 23:33:33 UTC
Re-visited:

Bug 619530 - app-emulation/vmware-workstation-12.5.{1-6}: 
             after minor version bump: 
             network connections "get lost"
             [WORKAROUND]

which was not needed any more in 12.5.7 :

[ https://bugs.gentoo.org/619530#c4 ]
Comment 31 Manfred Knick 2017-11-13 19:37:18 UTC
Missing epatch_user

In vmware-modules:

src_prepare() {
        ...
	# Allow user patches so they can support RC kernels and whatever else
	default
}

Trying to digest
[ https://blogs.gentoo.org/mgorny/2015/11/13/the-ultimate-guide-to-eapi-6/ ] ,
I'm not sure if
. . . EAPI=5 -> epatch_user
has become a default inherited by
. . . EAPI=6 -> default -> eapply_user
running
. . . /etc/portage/patches/...
auto-magically.

@ Ștefan : can you confirm ?
Comment 32 Ștefan Talpalaru 2017-11-14 22:28:08 UTC
Sorry for the delay.

I have added the installer's runtime dependencies to vmware-workstation-r2 in my overlay:

sys-libs/ncurses:0 (no need for the "5" slot, "0" works just fine)
sys-libs/readline:0

Thanks for the tip, I did not notice that the Bash script at the top of the bundle unpacks the Python installer and runs it to do the actual extraction. I checked everything it loads with "strace -e open ./VMware-Workstation-Full-14.0.0-6661328.x86_64.bundle --console --extract tmp".

Looks like your problems with vmware-modules stemmed from copying my ebuild, but not the associated patches in the "files" dir. Simplify your initial conditions and just "layman -a stefantalpalaru" to get everything. Let me know if you still have build or runtime issues.

By the way, for some reason that escapes me, you need to reload VMWare's kernel modules after each emerge of the workstation, like this: "emerge vmware-workstation && /etc/init.d/vmware restart".

Here are the other changes from the vmware-workstation version in the "vmware" overlay:

- moved to EAPI 6
- dropped the "vmware-bundle" eclass because it failed to unpack the installer which is now needed at runtime; I'm running the bundle itself to unpack it.
- moved to the "Full" bundle that has most of the tools, in order to replace the separate vmware-tools package (no tool is installed by default, you need to enable the corresponding USE flags)
- OS X / macOS specific tools were added
- the systemd scripts are conditionally downloaded based on the new "systemd" USE flag
- moved from the deprecated fdo-mime to xdg-utils
- added some missing licenses to the list
- added OS X / macOS guest support (mostly based on the Arch Linux package) - all under the "macos-guests" USE flag
- updated the list of bundled libs we can safely replace and the list of corresponding packages
- dropped the vmware-player package because "vmplayer" is installed by the workstation ebuild. I know a separate package would be a bit smaller, but it's just not worth the trouble duplicating most of such a complex ebuild (or complicating it further with ebuild-name-based conditionals).
- used chrpath to delete a problematic rpath in vmware-ovftool/libcurl.so.4
- installed the sbin/* binaries even when not installing the server, because they are needed by the "vmware" binary
- worked around the removed "wrapper-gtk24.sh"
- added "/etc/vmware-installer" to CONFIG_PROTECT_MASK
- added some new substitutions to /etc/vmware/hostd/config.xml - needed by /etc/init.d/vmware-server
- fixed vmware-usbarbitrator killing in /etc/init.d/vmware

Changes to vmware-modules:

- moved to EAPI 6
- dropped vmware-player as an alternative dependency
- replaced existing patches with new ones from https://aur.archlinux.org/packages/vmware-workstation/ and https://github.com/mkubecek/vmware-host-modules/tree/workstation-14.0.0
Comment 33 Ștefan Talpalaru 2017-11-14 22:45:30 UTC
files/vmware-14.0.rc was missing some fixes from the "vmware" repo - those mentioned in bug #510156. Added now.
Comment 34 Manfred Knick 2017-11-16 17:28:10 UTC
Stefan,

first of all: Thank you for your engagement!

@ "layman -a stefantalpalaru" :

For testing purposes, I explicitly don't want to have your complete overlay installed - otherwise, I would not detect "things missing".

So I only fetch your (sub-) directories
. . . app-emulation/vmware-{wowrkstation|modules}

That said, there is still a problem with
>>> Unpacking source...

 * The specific snippet of code:
 *       ./${bundle} --console --extract extracted || die
                                           "unable to extract bundle";
No extracts in .../work .

Changing DEPEND="
. . . sys-libs/ncurses:0
back to
. . . sys-libs/ncurses:5/5

:: extraction works.

With 

USE="cups doc ovftool server vix vmware-tools-freebsd vmware-tools-linux vmware-tools-windows -bundled-libs -macos-guests -systemd -vmware-tools-darwin -vmware-tools-darwinPre15 -vmware-tools-linuxPreGlibc25 -vmware-tools-netware -vmware-tools-solaris -vmware-tools-winPre2k -vmware-tools-winPreVista"

Install fails with 

usr/bin/install: cannot stat 'vmware-tools-freebsd/freebsd.iso': 
                                                     No such file or directory

!!! doins: vmware-tools-freebsd/freebsd.iso does not exist

although

# ll /var/tmp/portage/app-emulation/vmware-workstation-14.0.0.6661328-r3/
                                                               work/extracted/

drwxr-xr-x  9 portage portage 320 16. Nov 17:56 vmware-installer
drwxr-xr-x  4 portage portage 100 16. Nov 17:56 vmware-network-editor
drwxr-xr-x  5 portage portage 120 16. Nov 17:56 vmware-network-editor-ui
drwxr-xr-x  6 portage portage 600 16. Nov 17:56 vmware-ovftool
drwxr-xr-x 11 portage portage 240 16. Nov 17:56 vmware-player-app
drwxr-xr-x  3 portage portage 100 16. Nov 17:56 vmware-player-setup
drwxr-xr-x  3 portage portage 120 16. Nov 17:56 vmware-tools-freebsd
drwxr-xr-x  3 portage portage 120 16. Nov 17:56 vmware-tools-linux
drwxr-xr-x  3 portage portage 120 16. Nov 17:56 vmware-tools-linuxPreGlibc25
drwxr-xr-x  3 portage portage 120 16. Nov 17:56 vmware-tools-netware
drwxr-xr-x  3 portage portage 120 16. Nov 17:56 vmware-tools-solaris
drwxr-xr-x  3 portage portage 120 16. Nov 17:56 vmware-tools-windows
drwxr-xr-x  3 portage portage 120 16. Nov 17:56 vmware-tools-winPre2k
drwxr-xr-x  3 portage portage 120 16. Nov 17:56 vmware-tools-winPreVista
drwxr-xr-x  6 portage portage 140 16. Nov 17:56 vmware-usbarbitrator
drwxr-xr-x  7 portage portage 220 16. Nov 17:56 vmware-vix-core
drwxr-xr-x  4 portage portage 100 16. Nov 17:56 vmware-vix-lib-Workstation1400
drwxr-xr-x 10 portage portage 220 16. Nov 17:56 vmware-vmx
drwxr-xr-x  5 portage portage 120 16. Nov 17:56 vmware-vprobe
drwxr-xr-x  9 portage portage 200 16. Nov 17:56 vmware-workstation
drwxr-xr-x 10 portage portage 280 16. Nov 17:56 vmware-workstation-server

Line 659 ff:

     insinto "${VM_INSTALL_DIR}/lib/vmware/isoimages"
     doins vmware-tools-${guest}/${guest}.iso
     doins vmware-tools-${guest}/${guest}.iso.sig

Placing a 
. . . cd "${S}"
between insinto and doins makes this work too.

CONFIRMATION:  +++ Both packages emerge +++
Comment 35 Manfred Knick 2017-11-16 18:31:23 UTC
Quick initial test:

     CONFIRMATION:

- starts and works a Fedora VM
- starts and works a Win-10 VM

     WARNING / HINT :

"env-update" shattered my former network configuration
                                 which contained two bridged networks.

I had to 
   - delete both via VMware's "Edit" --> "Virtual Network Editor"
   - re-create both

   - edit /etc/vmware/netmap.conf manually

Even worse:

With every new emerge, env-update will shatter it again!, so take care.

Perhaps this may be correlated to the existence of 

. . . "More than one Bridged Network".
Comment 36 Ștefan Talpalaru 2017-11-16 18:47:52 UTC
I switched to ncurses:5 and fixed the current directory problem (a couple of "if" blocks were forgetting to change back to the previous dir).

I don't see how we can fix your networking problem. "/etc/vmware" should be under CONFIG_PROTECT control and the networking setup should be in "/etc/vmware/networking".
Comment 37 Manfred Knick 2017-11-16 23:15:51 UTC
(In reply to Ștefan Talpalaru from comment #36)
> I switched to ncurses:5 and fixed the current directory problem (a couple of
> "if" blocks were forgetting to change back to the previous dir).
That was quick!
 
> I don't see how we can fix your networking problem.
Not really a 'problem' for me - just mention to others.

There is a long history of VMware 
not correctly reading their own configuration files, 
as referenced above in my comment 30 (and pre-decessor links therein);
especially the first Release Minor typically got hit.

> "/etc/vmware" should be
> under CONFIG_PROTECT control and the networking setup should be in
> "/etc/vmware/networking".

etc-update is
- not called for /etc/vmware/networking
but
- gets called for /etc/vmware/config
- gets called for /etc/vmware/netmap.conf


P.S.: HINT for newcomers: (very roughly speaking)

- /etc/vmware/config hold general VMware config,

- /etc/vmware/networking maps existing "real" networks to VMware-internal,
- /etc/vmware/netmap.conf 'exports' internal to VMs
Comment 38 Manfred Knick 2017-11-16 23:47:23 UTC
Test again:

A) Cleaning:
- emerge -aC vmware-workstation vmware-modules
- emerge -a --depclean
- rm -r /var/tmp/portage/*

B) Re-build:
- emerge -auDN vmware-workstation

C) Start VMs



A) unmerge:

   var/tmp/portage/._unmerge_/app-emulation/
                        vmware-workstation-14.0.0.6661328-r3/temp/environment:
   line 2919:
   fdo-mime_desktop_database_update:
   command not found

B) works

   ( still env-update ...  as expected )

+  /etc/init.d/vmware { start | stop | status }

+  Networking

C) works


Overall Impression: _much_ quicker, compared to 12.5.*
Comment 39 Manfred Knick 2017-11-16 23:49:59 UTC
P.S.:   currently :    working @ 4.13.13
Comment 40 Manfred Knick 2017-11-16 23:56:56 UTC
Created attachment 504530 [details]
/usr/local/portage/local-overlay/app-emulation.tar

 /usr/local/portage/local-overlay :: app-emulation.tar

as extracted from Stefan's overlay ( c.f. comment 32 ) ( + digest )
Comment 41 Ștefan Talpalaru 2017-11-17 00:21:20 UTC
pkg_postrm() fixed in vmware-workstation-14.0.0.6661328-r5
Comment 42 Manfred Knick 2017-11-17 14:11:40 UTC
Created attachment 504564 [details]
/usr/local/portage/local-overlay/app-emulation.tar

This version contains

- vmware-workstation-12.5.8.7098237.ebuild            <--- BUG 637922

- vmware-workstation-14.0.0.6661328-r5.ebuild         <--- this BUG

All older versions  (<= 12.5.7) are obsolete.
Comment 43 Kelly Price 2017-11-23 12:48:54 UTC
*** Bug 635688 has been marked as a duplicate of this bug. ***
Comment 44 Manfred Knick 2017-11-25 14:30:13 UTC
0.   Running 4.13.15,
1.   Install 4.13.16,
2.   re-emerge (-1) app-emulation/vmware-workstation-14.0.0,

the modules get correctly placed into /lib/modules/4.13.16/misc.

3.   Re-Booting into 4.13.16, modprobe fails for 'vmmon' and 'vmblock':

. . . ERROR: could not insert ... : Exec format error


4.   re-emerge (-1) app-emulation/vmware-workstation-14.0.0 
     under 4.13.16 again,

5.   Re-Booting into 4.13.16 works, 
     loading the afore mentioned modules flawlessly.
Comment 45 Manfred Knick 2017-11-25 14:36:15 UTC
Just remembered that this has already happened in the transition 
from 4.13.14 to 4.13.15 already.
Comment 46 Manfred Knick 2017-11-25 14:41:34 UTC
(In reply to Manfred Knick from comment #44 and #45 above)

A)

Sorry - wrong edit window - these belong into 

. . . Bug 634862 - [vmware] app-emulation/vmware-modules-329: version bump

B) 

Please, in #44 and #45 above,

   s / app-emulation/vmware-workstation-14.0.0 / 
       app-emulation/vmware-modules-329

Sorry for the noise.
Comment 47 Ștefan Talpalaru 2017-11-25 14:45:41 UTC
I just upgraded the kernel and emerged vmware-modules-329.0.0-r2 through the usual "emerge @module-rebuild". There were no problems.

Are you using an older version of my ebuild, by any chance? Old ones were getting their kernel version from the running kernel instead of the eclass-supplied KERNEL_DIR: https://github.com/stefantalpalaru/gentoo-overlay/issues/17
Comment 48 Manfred Knick 2017-11-25 15:07:35 UTC
(In reply to Ștefan Talpalaru from comment #47)

> Are you using an older version of my ebuild, by any chance? 

There was no mention of your upgrade to vmware-modules-329.0.0-r2 ,

so yes, I missed that 

and will test it again soon 
with the transition from 4.13.* to 4.14.* .

But please, let's continue that issue in the appropriate Bug 634862.


! Thanks for your efforts.

This weekend, I intend to re-build half a dozen VMs.
If everything works as expected, 
I would like to suggest including your proposal 
into the official VMWARE Overlay.
Comment 49 Manfred Knick 2017-11-25 16:13:00 UTC
Freshly copied your Overlay some minutes ago:

>>> Verifying ebuild manifests

!!! A file is not listed in the Manifest: 

'/usr/local/portage/local-overlay/app-emulation/vmware-workstation/
                                 vmware-workstation-14.0.0.6661328-r5.ebuild'

Re-building the Manifest, emerge works.
Comment 50 Kelly Price 2017-11-25 16:15:56 UTC
Heya!  I'm testing from Stefan's overlay, and everything's looking good.  You may want to block on app-emulation/vmware-tools from the vmware overlay, as it has a file conflict on the ISO's used.

Also, I think VMWare wanted to install fresher ISOs than bundled when I installed Win10...
Comment 51 Manfred Knick 2017-11-25 16:27:52 UTC
(In reply to Kelly Price from comment #50)

> Heya!  I'm testing from Stefan's overlay, and everything's looking good.

That's very fine for you.

But I'm not testing Stefan's non-official big overlay:

My question is about Stefan's proposal being mature stand-alone
to be incorporated into official VMware Overlay.

> You may want to block on app-emulation/vmware-tools from the vmware overlay,
> as it has a file conflict on the ISO's used.

Before insinuating your presumptions as facts:

At the moment, I have  
- neither added VMware Overlay to my tree
- nor _any_ version of vmware-tools available at all.

> Also, I think VMWare wanted to install fresher ISOs than bundled when I
> installed Win10...

I disagree.
Comment 52 Ștefan Talpalaru 2017-11-25 16:39:02 UTC
(In reply to Kelly Price from comment #50)
> You may want to block on app-emulation/vmware-tools from the vmware overlay,
> as it has a file conflict on the ISO's used.

Blocker added in vmware-workstation-14.0.0.6661328-r6.
Comment 53 Manfred Knick 2017-11-25 16:48:54 UTC
(In reply to Ștefan Talpalaru from comment #52)

> ... vmware-workstation-14.0.0.6661328-r6.

* Missing digest for
  '/usr/local/portage/local-overlay/app-emulation/vmware-workstation/
                                   vmware-workstation-14.0.0.6661328-r6.ebuild'
Comment 54 Manfred Knick 2017-11-25 16:50:58 UTC
(In reply to Manfred Knick from comment #53)

> * Missing digest for

Is this the same intention as 
"no need" in https://bugs.gentoo.org/634862#c8 ?
Comment 55 Ștefan Talpalaru 2017-11-25 16:54:39 UTC
Yes, these manifest problems that you have stem from your use of regular manifests in your overlay, while I use thin ones in mine.
Comment 56 Manfred Knick 2017-11-29 10:25:38 UTC
Created attachment 507062 [details]
app-emulation_vmware-r2-r6.tar

app-emulation_vmware-r2-r6.tar contains Stefan's
-  vmware-workstation-14.0.0.6661328-r6
-  vmware-modules-329.0.0-r2
Comment 57 Manfred Knick 2017-11-29 11:35:37 UTC
(In reply to Manfred Knick from comment #56)

During the last days, exploiting
> -  vmware-workstation-14.0.0.6661328-r6     and
> -  vmware-modules-329.0.0-r2
provided in Ștefan Talpalaru's overlay [comment 17],
I successfully re-built a whole bunch of VMs a-new,
including

-- Windows : 7,  8.1,  10.1709
-- Linux   : Fedora, OpenSUSE
-- Unix    : FreeBSD 11.1

without any problems at all.

A big "Thank You!" to Stefan Talpalaru
for porting the arch package,
adopting and developing it to the current state.

CONFIRMATION :       WORKSFORME .
Comment 58 Manfred Knick 2017-11-29 12:10:22 UTC
! Once again :

> @ Gentoo VMWare Team : 

    Your DECISION is REQUIRED:

o) concerning tools : c.f. https://bugs.gentoo.org/634854#c3

o) pull Stefan Talpalaru's solution into [vmware] overlay

( @ Stefan: only if you don't mind, of course )
Comment 59 Manfred Knick 2017-11-29 15:59:51 UTC
REFERENCE:

Bug 639162 - [vmware] app-emulation/vmware-player-14.0.0 version bump 
             [for "stable", excluding "~amd64"]
Comment 60 Manfred Knick 2017-12-02 10:10:57 UTC
REFERENCE:

   ...
   with Stefan's vmware-workstation-14.0.0.6661328-r10,
      it is possible to dynamically switch between installations 
      with valid { modules | server } combinations.

[ https://bugs.gentoo.org/604426#c7 ]


This valuable ENHANCEMENT allows to use Workstation
as a pure maintenance head for e.g.

- pure ESXi Hypervisor hosts   ( free of cost )

as well as

- full vSphere nodes.


Without Modules loaded / local VMware VMs started,
you can

- run KVM Hypervisor / start KVM VMs on your system locally

and

- maintain VMware VMs on remote hosts 

! at the same time !
Comment 61 Manfred Knick 2018-01-18 14:41:34 UTC
Obsolete: Multiple CVE

--> Bug 644946 - [vmware] app-emulation/vmware-workstation-14.1.1 version bump